#ifndef _SYS_SIGNAL_H
#define _SYS_SIGNAL_H
#ifndef _SIGNAL_H
#include <signal.h>
#endif
#ifdef __STDC__
#define _P_(params) params
#else
#define _P_(params)
#endif
#ifndef _SIGSET_T
typedef unsigned long sigset_t;
#define _SIGSET_T
#endif
struct SIG_PRIOR_R {
unsigned norm :3;
unsigned susp :3;
unsigned wfio :3;
unsigned wfjob:3;
unsigned req_sigstack:1;
unsigned reserved : 19;
};
struct SIG_PRIOR_S {
unsigned norm : 3;
unsigned susp : 3;
unsigned wfio : 3;
unsigned wfjob: 3;
unsigned df_susp : 1;
unsigned df_wfio : 1;
unsigned df_wfjob : 1;
unsigned retry_sigsend :1;
unsigned reserved : 16;
};
struct SIG_MSG {
unsigned long magic;
unsigned long len;
unsigned short type;
unsigned short txi;
unsigned long jobid,signr;
struct SIG_PRIOR_S prio;
unsigned long uval;
};
struct TMR_MSG {
unsigned long magic;
unsigned long len;
unsigned short type;
unsigned short txi;
unsigned long jobid,signr;
struct SIG_PRIOR_S prio;
unsigned long uval;
unsigned long t_evid;
unsigned long t_ticks;
unsigned long t_int;
};
#define M_SIG 0
#define M_TIMER 1
#define MT_TICKS 0
#define MT_SECS 1
#define EV_ALARM 1
struct QDOS_SIGH {
unsigned short m1;
unsigned long m2;
void (*sighandler)(void);
char * stackmin;
struct SIG_PRIOR_R priority;
};
struct QDOS_CSIGH {
unsigned short m1;
unsigned long m2;
unsigned nsig;
void (*** curr) (int) ;
void (*** def) (int) ;
sigset_t **samask;
unsigned short prot_id;
union {unsigned short levl;
unsigned short **plevl;} hprotlevel;
unsigned short stack_id;
char * stackmin;
unsigned short pri_id;
union {struct SIG_PRIOR_R prio;
struct SIG_PRIOR_R **pprio; } priority;
void *siginfo;
int (*sigvec)(int,...);
unsigned short cprotlevel;
unsigned short defer;
unsigned short activ;
long **uval;
sigset_t block;
sigset_t pending;
sigset_t resethandler;
};
struct SREGS {
datareg_t d0,d1,d2;
addreg_t a0,a1;
};
#define SGN_NORM 0
#define SGN_WFIO 1
#define SGN_WFJB 2
#define SGN_SUSP 3
#define SGN_RAISE 4
struct SIGSVB {
void (*sig_clup)(void);
short signature;
long sf1,sf2;
datareg_t d4,d5,d6;
addreg_t a4,a5,a7;
short sr;
long ret_addr;
};
struct ESVB {
struct SIGSVB sigsvb;
sigset_t oblock;
long ohand;
long signr;
struct QDOS_CSIG *hptr;
long uval;
datareg_t d0,d1,d2;
addreg_t a0,a1;
};
extern struct QDOS_CSIGH _sigh;
typedef short SigProtState_t;
#define sigmask(i) ((sigset_t)(1 << (i-1)))
#ifdef OLD
struct C_HANDLER {
unsigned nsig;
sigset_t sigpend;
sigset_t sigblock;
SigProtState_t sigprotect;
sigset_t sigreset;
void (*(* sigcurrent)[_NSIG+1]) (int) ;
void (*(* sigdefault)[_NSIG+1]) (int) ;
sigset_t (*sigsamask)[_NSIG+1] ;
};
extern struct C_HANDLER _sigcontrol;
extern void (* __sigcurrent[_NSIG+1])(int);
extern void (* __sigdefault[_NSIG+1])(int);
extern sigset_t __sigsamask[_NSIG+1];
#endif
extern chanid_t _sigch;
#ifdef DEBUG
extern chanid_t _sigdebugch;
extern int _sigdebug;
extern int sigprintf();
#endif
extern long _spbase;
extern long _stackmargin;
extern struct SIG_PRIOR_R _defsigrp;
extern struct SIG_PRIOR_S _defsigsp;
extern struct SIG_PRIOR_S _defsigskp;
#ifdef OLD
#define SIGF_BLK 0x1
#define SIGF_RES 0x2
extern long _defsigblock;
void _sigwrap(void);
void checksig(void);
void _call_sighandler(int);
#endif OLD
int sendsig(chanid_t,jobid_t,long,struct SIG_PRIOR_S,long );
void _init_sigrec(void);
int set_timer_event(struct TMR_MSG *);
#define SIGPROTSTATE_PROTECTED ((char) 1)
#define SIGPROTSTATE_UNPROTECTED ((char) 0)
#define SAVESIGPROTSTATE(var) {var = _sigcontrol.sigprotect;}
#define SETSIGPROTSTATE(state) {_sigcontrol.sigprotect = state;}
#define SYSCALLV(fun) {SigProtState_t _SCi_; SAVESIGPROTSTATE(_SCi_);\
SETSIGPROTSTATE(SIGPROTSTATE_PROTECTED); \
(void) fun ;\
SETSIGPROTSTATE(_SCi_) ; \
if(_sigcontrol.sigpend) checksig(); }
#define SYSCALLASSIGN(var,fun) {SigProtState_t _SCi_; SAVESIGPROTSTATE(_SCi_);\
SETSIGPROTSTATE(SIGPROTSTATE_PROTECTED); \
var=(fun) ; \
SETSIGPROTSTATE(_SCi_) ; \
if(_sigcontrol.sigpend) checksig(); }
#define SYSCALLRET(fun,rtype) {rtype _SCr_; SigProtState_t _SCi_; \
SAVESIGPROTSTATE(_SCi_); SETSIGPROTSTATE(SIGPROTSTATE_PROTECTED)\
_SCr_=(fun); \
SETSIGPROTSTATE(_SCi_);\
if(_sigcontrol.sigpend) checksig();return _SCr_; }
#if 0
extern struct _sigcontrol {
int count;
sigset_t mask;
sigset_t pend;
sigset_t block;
long alarm;
void (*handler[_NSIG+1])_P_((int));
} _sigcurrent;
extern void (*_sigdefault [_NSIG+1])_P_((int));
#define _SIG_UNBLOCKABLE (SIGABRT | SIGKILL)
extern char _SigSend;
extern pid_t _SigSendPid;
extern long _SigSendPriority;
extern char * _SigSendAddress;
extern int _SigSendNum;
extern char _SigSendEnd;
void _chksig _P_((void));
void _sigdie _P_((int));
void _sigignore _P_((int));
void _sigreport _P_((int));
void (*_signal _P_((int,void (*)_P_((int)))))_P_((int));
#endif
extern int _CheckSig _P_((void));
extern void _onsigkill _P_((int));
#define _SIG_TERMINATE 0
#define _SIG_ABNORMAL 1
#define _SIG_IGNORE 2
#define _SIG_STOP 3
#define _SIG_ALARM 4
#define _SIG_TERMINATE 0
#define _SIG_ABNORMAL 1
#define _SIG_IGNORE 2
#define _SIG_STOP 3
#define _SIG_ALARM 4
#define _SIG_UNBLOCKABLE sigmask( SIGKILL )
#ifdef OLD
extern char __inabort;
#endif
extern char * __SigNoMsg;
extern sigset_t * __SigSaMask[_NSIG+1];
extern void (* __SigCurrent[_NSIG+1]) (int);
extern void (* __SigDefault[_NSIG+1]) (int);
extern long *__SigUval[_NSIG+1];
extern int _SigNoImp(int,...);
#endif
